/*
  S-format ̃p[X
  Satofumi KAMIMURA
  $Id$
*/

#include "stdafx.h"

#include "sformat.h"


/* 16i𐮐^ɒ */
static int hex2int(char ch) {
  if (ch >= '0' && ch <= '9') {
    return ch - '0';
  } else {
    return (ch - 'A' + 10);
  }
}


/* S-format ̃f[^\̂Ɋi[ĕԂ */
int parseSFormat(char *line, srec_t *srec) {
  int index = 0;
  int addr_size = 2;
  int byte_size;
  int i;
  unsigned char check_sum;
  unsigned char data_sum;

  if (line[index++] != 'S') {	/* ŏ̕ 'S' ǂ */
    return -1;
  }
  
  srec->type = line[index++] - '0'; /* type ̊i[ */

  /* byte_size ̊i[ */
  byte_size = (hex2int(line[index]) << 4) + hex2int(line[index + 1]);
  index += 2;

  /* address ̊i[ */
  if (srec->type >= 1 && srec->type <= 3) {
    addr_size = srec->type + 1;
  } else if (srec->type >= 7 && srec->type <= 9) {
    addr_size = 11 - srec->type;
  }
  srec->address = 0;
  for (i = 0; i < 2*addr_size; ++i) {
    srec->address = (srec->address << 4) + hex2int(line[index++]);
  }

  /* byte_data ̊i[ */
  srec->data_size = byte_size - addr_size - 1;
  for (i = 0; i < srec->data_size; ++i) {
    srec->byte_data[i] =
      (hex2int(line[index]) << 4) + hex2int(line[index + 1]);
    index += 2;
  }
  
  /* check sum ̎擾ƃ`FbN */
  check_sum = (hex2int(line[index]) << 4) + hex2int(line[index + 1]);
  index += 2;
  data_sum = 0;
  for (i = 0; i <= (srec->data_size + addr_size); ++i) {
    data_sum += (hex2int(line[2*i+2]) << 4) + hex2int(line[2*i+3]);
  }
  if (check_sum != (~data_sum & 0xff)) {
    return -1;
  }
  
  return 0;
}
