/*
  SH7045F ɓ]鏑݃vO
  Satofumi KAMIMURA
  $Id$
*/

#include "cpu_spec.h"
#include "wctrl.h"


enum {
  SCI_BIT_WAIT = (int)(CPU_CLOCK / 38400.0 / 7.0),
};


struct st_flm {
  struct { unsigned char BYTE; } FLMCR1;
};


#define LOOP(X) for(i = X; i > 0; i--) /* Wait Loop */


/* PM */
void putch(char ch) {
  while ((SCI1.SSR.BYTE & 0x80) == 0) /* TDRE */
    ;
  SCI1.TDR = ch;
  SCI1.SSR.BYTE  &= ~0x80;
}


/* PM */
char getch(void) {
  char ch;
  
  while((SCI1.SSR.BYTE & 0x40) == 0) /* RDRF */
    ;
  ch = SCI1.RDR;
  SCI1.SSR.BYTE &= ~0x40;	/* clear RDRF */

  return ch;
}


/* F-ZTAT ւ̏ */
int writeROM(int addr, char *data) {
  volatile char *address = (char *)addr;
  volatile char *flmcr = (char *)FLMCR1_ADDR;
  volatile int i = 0;		/* use LOOP() */
  char rewrite[32];
  char verify;
  int n, m, j;

  if (addr > 0x0001ffff) {
    flmcr += 1;
  }

  FLM.FLMCR1.BYTE |= 0x40;	/* FLMR1 SWE=1 */
  LOOP(WAIT_10u);

  for (j = 0; j < 32; ++j) {
    rewrite[j] = data[j];
  }

  n = 1;
  do {
    for (j = 0; j < 32; ++j) {	/* data byte write */
      *(address + j) = rewrite[j];
    }

    WDT_TCSR_WORD = WDT_573u; /* set WDT */
    
    *flmcr = 0x50;		/* set FLMCR1(2) PSU1(2)=1 */
    LOOP(WAIT_50u);

    *flmcr = 0x51;		/* set FLMCR1(2) P1(2)=1 */
    LOOP(WAIT_200u);

    *flmcr = 0x50;		/* set FLMCR1(2) P1(2)=0 */
    LOOP(WAIT_10u);

    *flmcr = 0x40;		/* set FLMCR1(2) PSU1(2)=0 */
    LOOP(WAIT_10u);

    WDT_TCSR_WORD = WDT_STOP;	/* stop WDT */
    *flmcr = 0x44;		/* set FLMCR1(2) PV1(2)=1 */
    LOOP(WAIT_4u);

    m = 0;
    for (j = 0; j < 32; j++) {
      *(address + j) = 0xff;
      rewrite[j] = 0xff;
      LOOP(WAIT_2u);
      verify = *(address + j);
      if (data[j] != verify) {
	m = 1;
      }
      rewrite[j] = ~(data[j] ^ verify) | data[j];
    }

    *flmcr = 0x40;		/* set FLMCR1(2) PV1(2)=0 */
    LOOP(WAIT_4u);
    
  } while ((m != 0) && (n++ < WRITE_TIMES));
  
  FLM.FLMCR1.BYTE = 0x00;	/* FLMR1 SWE=0 */
  if (m != 0) {
    return -1;
  }
  return 0;
}


void __main(){};
int main(void) {
  unsigned char data[32];
  unsigned long addr;
  int j;
  volatile int i;
  char ch;

  /* VAfoCX̏ */
  SCI1.SCR.BYTE = 0x00;
  SCI1.SMR.BYTE = 0;		/* 8bit, 1stop,no parity */
  SCI1.BRR = 22;		/* 38400 bps */
  PFC.PACRL2.WORD |= 0x0140;	/* enable RxD1, TxD1 */
  for (i = 0; i < SCI_BIT_WAIT; ++i) /* wait 1 bit */
    ;
  SCI1.SCR.BYTE = 0x30;		/* TE = 1, RE = 1 */
  SCI1.SSR.BYTE &= ~0x40;

  /* f[^Mď */
  getch();		    /* zXgJn̍}̂҂ */
  putch('.');
  while (1) {
    /* ݃f[^MAɃGR[obN */
    addr = 0;
    for (j = 0; j < 4; ++j) {
      ch = getch();
      addr = (addr << 8) + (unsigned char)ch;
      putch(ch);
    }
    for (j = 0; j < 32; ++j) {
      ch = getch();
      data[j] = (unsigned char)ch;
      putch(ch);
    }

    /* F-ZTAT ւ̏ */
    if (writeROM(addr, data) < 0) {
      putch(':');			/* ݂Ɏs */
    } else {
      putch('.');			/* ̏݃f[^𑣂 */
    }
  }
}
